#!/usr/bin/perl -w
use strict;

my ($filename,$name,$description,$kml);
if (@ARGV == 1 || @ARGV == 2|| @ARGV == 3) {
    $filename =  $ARGV[0];
    $name = defined $ARGV[1] ? $ARGV[1] : 'Wireless APs';
    $description = defined $ARGV[2] ? $ARGV[2] : undef;
}
else {
    print "Usage: $0 Kismet.csv [name] [description]\n";
}
open (FILE,$filename);
my @data = <FILE>;
close(FILE); 
my $counter=0;

$kml =  "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
$kml .= "<kml xmlns=\"http://earth.google.com/kml/2.0\">\n";
$kml .= "<Document>\n";
$kml .= "  <name>$name</name>\n";

if (defined($description)) {
    $kml .= "  <description> $description</description>\n";
}

=begin

<Style id="default_copy0+icon=http://maps.google.com/mapfiles/kml/pal3/icon63.png">
        <IconStyle>
            <Icon>
                <href>http://maps.google.com/mapfiles/kml/pal3/icon63.png</href>
            </Icon>
        </IconStyle>
    </Style>
    <StyleMap id="default_copy0+nicon=http://maps.google.com/mapfiles/kml/pal3/icon63.png+hicon=http://maps.google.com/mapfiles/kml/pal3/icon55.png">
        <Pair>
            <key>normal</key>
            <styleUrl>#default_copy0+icon=http://maps.google.com/mapfiles/kml/pal3/icon63.png</styleUrl>
        </Pair>
        <Pair>
            <key>highlight</key>
            <styleUrl>#default_copy0+icon=http://maps.google.com/mapfiles/kml/pal3/icon55.png</styleUrl>
        </Pair>
    </StyleMap>
    <Style id="default_copy0+icon=http://maps.google.com/mapfiles/kml/pal3/icon55.png">
        <IconStyle>
            <scale>1.1</scale>
            <Icon>
                <href>http://maps.google.com/mapfiles/kml/pal3/icon55.png</href>
            </Icon>
        </IconStyle>
        <LabelStyle>
            <scale>1.1</scale>
        </LabelStyle>
    </Style>
=end
=cut

foreach my $line (@data) {
    if  ($counter==0) {
        $counter=$counter+1;
        next;
    }

    my @WD=split(';',$line);
    my @mykeys=("Network","NetType","ESSID","BSSID","Info","Channel","Cloaked","Encryption","Decrypted","MaxRate","MaxSeenRate","Beacon","LLC","Data","Crypt","Weak","Total","Carrier","Encoding","FirstTime","LastTime","BestQuality","BestSignal","BestNoise","GPSMinLat","GPSMinLon","GPSMinAlt","GPSMinSpd","GPSMaxLat","GPSMaxLon","GPSMaxAlt","GPSMaxSpd","GPSBestLat","GPSBestLon","GPSBestAlt","DataSize","IPType","IP");
   
    
    
    my %HoH = ();
    my $index=0;

    foreach my $thekey(@mykeys) {
        $HoH{$thekey}=$WD[$index];
        $index++;
    }

    if($HoH{'NetType'} ne  "infrastructure" ) {   
        next; 
    }
    if($HoH{'GPSBestLat'}==0 or $HoH{'GPSBestLat'}==0) {
        next;
    }

    $kml .= "\n <Placemark>\n";
    $HoH{'ESSID'} =~ s/\</_/g;
    $HoH{'ESSID'} =~ s/\>/_/g;
    $kml .= "    <name>$HoH{'ESSID'}</name>\n";
    $kml .= "    <description><![CDATA[BSSID $HoH{'BSSID'}<br>";
    $kml .= 'channel: ' . $HoH{'Channel'}  . '<br>';
    $kml .= '<font color="green">encryption: ' . $HoH{'Encryption'}  . '</font><br>';
    $kml .= "]]></description>\n";
    $kml .= "    <Point>\n";
    $kml .= "      <coordinates>$HoH{'GPSBestLon'},$HoH{'GPSBestLat'},0</coordinates>\n";
    $kml .= "    </Point>\n";
    $kml .= "  </Placemark>\n";
    $counter = $counter+1;
}
$kml .= "\n</Document>\n";
$kml .= "</kml>\n";
print $kml;
