#!/usr/bin/perl -w
use strict;
use DBI;
####################Configuration ###########
my $user       = '';
my $password   ='';
my $dbase      = 'wireless.dbl';
my $counter=0;
my $dbh = DBI->connect(
    "dbi:SQLite:$dbase",
    "$user",
    $password,
    {   PrintError => 0,
        RaiseError => 0,
        AutoCommit => 1
    }
) || die "Cannot connect: $DBI::errstr";


my $sql = qq/SELECT BSSID, ESSID, Encryption, GPSBestLat, GPSBestLon FROM wireless ; /;

my $sth = $dbh->prepare($sql);
if (defined($sth)){
    my $tmp = $sth->execute;
}
else {
    print "Broken SQL Query\n";
    exit 1;
}

print("set term png small\n");
print("set title \"Wireless AP's\"\n");
print("set ylabel \"Latitude\"\n");
print("set xlabel \"Longitude\"\n");
print("plot \"-\" with points\n");
while(my $ref = $sth->fetchrow_hashref()) {
    print("$ref->{'GPSBestLon'} $ref->{'GPSBestLat'}\n");
}
